.module CPM

; Basic Disk Operating System (BDOS) entry point.
BDOS = $0005

; Address of the Transient Program Area (TPA).
TPA = $0100

; Basic Disk Operating System (BDOS) function numbers.
BDOS.P_TERMCPM    =  0
BDOS.C_READ       =  1
BDOS.C_WRITE      =  2
BDOS.A_READ       =  3
BDOS.A_WRITE      =  4
BDOS.L_WRITE      =  5
BDOS.C_RAWIO      =  6
BDOS.A_STATIN     =  7
BDOS.A_STATOUT    =  8
BDOS.C_WRITESTR   =  9
BDOS.C_READSTR    = 10
BDOS.C_STAT       = 11
BDOS.S_BDOSVER    = 12
BDOS.DRV_ALLRESET = 13
BDOS.DRV_SET      = 14
BDOS.F_OPEN       = 15
BDOS.F_CLOSE      = 16
BDOS.F_SFIRST     = 17
BDOS.F_SNEXT      = 18
BDOS.F_DELETE     = 19
BDOS.F_READ       = 20
BDOS.F_WRITE      = 21
BDOS.F_MAKE       = 22
BDOS.F_RENAME     = 23
BDOS.DRV_LOGINVEC = 24
BDOS.DRV_GET      = 25
BDOS.F_DMAOFF     = 26
BDOS.DRV_ALLOCVEC = 27
BDOS.DRV_SETRO    = 28
BDOS.DRV_ROVEC    = 29
BDOS.F_ATTRIB     = 30
BDOS.DRV_DPB      = 31
BDOS.F_USERNUM    = 32
BDOS.F_READRAND   = 33
BDOS.F_WRITERAND  = 34
BDOS.F_SIZE       = 35
BDOS.F_RANDREC    = 36
BDOS.DRV_RESET    = 37
BDOS.DRV_ACCESS   = 38
BDOS.DRV_FREE     = 39
BDOS.F_WRITEZF    = 40
BDOS.F_LOCK       = 41
BDOS.F_UNLOCK     = 43
BDOS.F_MULTISEC   = 44
BDOS.F_ERRMODE    = 45
BDOS.DRV_SPACE    = 46
BDOS.P_CHAIN      = 47
BDOS.DRV_FLUSH    = 48
BDOS.S_SYSVAR     = 49

; System Control Block (SCB) data offsets.
SCB.CIVEC = $22 ; Console Input Redirection Vector (word, r/w)
SCB.COVEC = $24 ; Console Output Redirection Vector (word, r/w)
SCB.AIVEC = $26 ; Auxiliary Input Redirection Vector (word, r/w)
SCB.AOVEC = $28 ; Auxiliary Output Redirection Vector (word, r/w)
SCB.LOVEC = $2A ; List Output Redirection Vector (word, r/w)
SCB.BNKBF = $35 ; Address of 128 Byte Buffer for Banked BIOS (word, r/o)
SCB.CRDMA = $3C ; Current DMA Address (word, r/o)
SCB.CRDSK = $3E ; Current Disk (byte, r/o)
SCB.VINFO = $3F ; BDOS Variable "INFO" (word, r/o)
SCB.RESEL = $41 ; FCB Flag (byte, r/o)
SCB.FX    = $43 ; BDOS Function for Error Messages (byte, r/o)
SCB.USRCD = $44 ; Current User Code (byte, r/o)
SCB.MLTIO = $4A	; Current Multi-Sector Count(byte,r/w)
SCB.ERMDE = $4B ; BDOS Error Mode (byte, r/o)
SCB.ERDSK = $51	; BDOS Error Disk (byte,r/o)
SCB.MEDIA = $54	; Set by BIOS to indicate open door (byte,r/w)
SCB.BFLGS = $57 ; BDOS Message Size Flag (byte,r/o)  
SCB.DATE  = $58 ; Date in Days Since 1 Jan 78 (word, r/w)
SCB.HOUR  = $5A ; Hour in BCD (byte, r/w)
SCB.MIN   = $5B ; Minute in BCD (byte, r/w)
SCB.SEC   = $5C ; Second in BCD (byte, r/w)
SCB.ERJMP = $5F ; BDOS Error Message Jump (word, r/w)
SCB.MXTPA = $62 ; Top of User TPA (address at 6,7) (word, r/o)

.endmodule